package Restore;
require CMONOS::CGI_Lib::SetUp;
@ISA = qw(SetUp);
use strict;
use utf8;
######################################################################
# 設定復元モジュール
# Restore.pm ver1.2.1
# Copyright (C) 1999-2015 CMONOS Co. Ltd.
# 
# support@cmonos.jp
# http://cmonos.jp/
# 最終更新日：2016-01-04
######################################################################
# 実行
sub run ($) {
my $this = shift;
if ($env::preference_dir && (!$default::subdivided || !defined $main::c || $main::c eq '')) {
	$backup::default{'table'} = 'table';
}

if (defined $main::a && $main::a eq 'r' && %main::restore) {
	my(%db_path,%db_name,$k,$ext);

	use Fcntl qw(:DEFAULT);
	eval 'use ' . $env::dbm_file . ';';

	%db_path = (%backup::db_path) ? %backup::db_path : ();
	%db_name = (%backup::db_name) ? %backup::db_name : ();
	if ($env::preference_dir && (!$default::subdivided || !defined $main::c || $main::c eq '')) {
		($db_path{'deco'},$db_name{'deco'}) = ($env::preference_dir . '/deco','画像設定（共通）') if $setting::deco;
		($db_path{'table'},$db_name{'table'}) = ($env::preference_dir . '/table','テーブル設定（共通）') if $setting::table;
	}
	($db_path{'pref'},$db_name{'pref'}) = ($default::preference_dir,'初期設定') if defined $default::preference_dir && $default::preference_dir;
	($db_path{'field'},$db_name{'field'}) = ($default::field_pref_dir,'フィールド設定') if $default::field_pref_dir && (!$default::subdivided || (defined $main::c && $main::c ne ''));

	#データベース・設定 の復元
	foreach my $k (sort keys %main::restore) {
		my $ext = $main::restore{$k};
		my $check = 0;
		my $default_dir = ($ext && $ext =~ s/^~// && $env::user_default_dir) ? $env::user_default_dir : $env::default_dir;
		my $default_path = ($backup::default{$k}) ? $default_dir . '/' . $backup::default{$k} : '';
		if (!$ext || ($ext ne 'bak' && $ext !~ /^[0-9a-zA-Z_]+\.default$/)) {
			next;
		} elsif (defined $db_path{$k} && -d $db_path{$k}) {
			$check = 1 if $this->restore_dir($default_path,$db_path{$k},$ext,$backup::find{$k});
			$this->restore_relational_files($ext,$default_dir) if $ext ne 'bak' && %backup::relational_file && $k eq 'pref';
		} elsif (defined $db_path{$k}) {
			$check = 1 if $this->restore_db($default_path,$db_path{$k},'',$ext);
		}
		if (defined $check && $check) {
			push(@{$this->{'dialog'}},$db_name{$k} . 'を復元しました。');
		} else {
			push(@{$this->{'dialog'}},$db_name{$k} . 'の復元に失敗しました。');
		}
	}
}

#ページヘッダ
$this->jump_menu('tools','backup');
$this->print_page_header('tools');

print '<h1>データベース・設定 の復元</h1>';

print $this->form_start(
	'key'	=>	'tools',
	'name'	=>	'input',
	'method'	=>	'post',
	'required'	=>	\@setting::form
);
print '<input type="hidden" name="a" value="r" />';

print '<fieldset><legend>復元可能なデータ</legend><table class="field-table"><tbody>';
if ($env::preference_dir && (!$default::subdivided || !defined $main::c || $main::c eq '')) {
	$this->print_backup_menu('deco',$env::preference_dir . '/deco','画像設定（共通）') if $setting::deco;
	$this->print_backup_menu('table',$env::preference_dir . '/table','テーブル設定（共通）') if $setting::table;
}
$this->print_backup_menu('pref',$default::preference_dir,'初期設定') if defined $default::preference_dir && $default::preference_dir;
$this->print_backup_menu('field',$default::field_pref_dir,'フィールド設定') if $default::field_pref_dir && (!$default::subdivided || (defined $main::c && $main::c ne ''));

if (%backup::db_name) {
	foreach (sort keys %backup::db_name) {
		$this->print_backup_menu($_,$backup::db_path{$_},$backup::db_name{$_},$backup::find{$_},$backup::skip{$_});
	}
}

if (defined $this->{'count'} && $this->{'count'}) {
	print '</tbody></table></fieldset><fieldset class="submit">';
	print '<label><input type="checkbox" name="clear" value="1" title="データベースの内容を全て消した後、設定を復元します。" /> 完全上書き</label> ';
	print '<input type="submit" value="復元" class="save" onclick="return confirm(\'現在のデータに上書きされます。本当に復元を実行しますか？\')" /></fieldset>';
} else {
	print '<tr><td>復元可能な設定ファイルがありません。</td></tr></tbody></table></fieldset>';
}

print '</form>';

#ページフッタ
$this->print_page_footer('tools');

}

######################################################################
# 復元メニュー
sub print_backup_menu ($$$$;$$) {
my($this,$key,$path,$name,$find,$skip) = @_;
return if !defined $key || !defined $path;
my %bak = ();

$this->get_backup_list_hash($path,\%bak,$find,$skip);
if ($backup::default{$key}) {
	$this->get_backup_list_hash($env::default_dir . '/' . $backup::default{$key},\%bak,$find,$skip);
	$this->get_backup_list_hash($env::user_default_dir . '/' . $backup::default{$key},\%bak,$find,$skip,1) if $env::user_default_dir;
}
return if !%bak;

print '<tr><td class="field-name"><label for="restore:', $key, '">';
print ((defined $name) ? $name : $key);
print '</label></td>';
print '<td class="field"><select name="restore:', $key, '" id="restore:', $key, '">';
print '<option value="">復元しない</option>';
print '<option value="bak">' . $bak{'bak'} . ' を復元する</option>' if $bak{'bak'};
foreach my $ext (sort keys %bak) {
	next if $ext eq 'bak';
	print '<option value="', $ext, '">';
	print $bak{$ext};
	print ' を復元する</option>';
}

print '</select></td></tr>';

$this->{'count'}++;
}

sub get_backup_list_hash ($$$;$$$) {
my($this,$path,$bak,$find,$skip,$user_dir) = @_;
my($db,@files);
if (-d $path) {
	$db = '[0-9a-zA-Z_]+';
} else {
	($path,$db) = ($1,$2) if $path =~ m!^(.*)/([^/]+)$!;
	$db =~ s/\.[^\/\.]+$//;
}
$path =~ s!/$!!;

return unless opendir(DIR,$path);
@files = grep($_ !~ /^\./,readdir(DIR));
closedir(DIR);

foreach my $file_name (@files) {
	if ($file_name =~ /^$db\.bak$/) {
		next if defined $$bak{'bak'} && $$bak{'bak'} ne '';
		$$bak{'bak'} = 'バックアップ';
		return if defined $skip && $skip;
	} elsif (!$skip && $file_name =~ /^$db\.([0-9a-zA-Z_]+\.default)$/) {
		my $ext = (($user_dir) ? '~' : '') . $1;
		next if defined $$bak{$ext} && $$bak{$ext} ne '';
		local(*FILE);
		if (open(FILE, "$path/$file_name")) {
			binmode FILE;
			my $name = <FILE>;
			close(FILE);
			chomp $name;
			$$bak{$ext} = $this->jcode_convert($name,'utf8');
			$$bak{$ext} .= '&lt;共有&gt;' if $env::user_default_dir && !$user_dir;
		}
	} elsif ($find && -d $path . '/' . $file_name) {
		$this->get_backup_list_hash($path . '/' . $file_name,$bak,$find,$skip,$user_dir);
	}
}
}

######################################################################
# ディレクトリ内のDBを復元
sub restore_dir ($$$$;$) {
my($this,$default_path,$path,$ext,$find) = @_;
my(@db,$check,%restore);
$path =~ s!/$!!;

return unless opendir(DIR,$path);
@db = readdir(DIR);
closedir(DIR);

foreach my $name (@db) {
	next if $name =~ /^[\-\.]/ || $name =~ /\.(txt|html|htm|gif|jpg|png)$/i;
	if (-d $path . '/' . $name) {
		$check = 1 if $find && $this->restore_dir($default_path,$path . '/' . $name,$ext,$find);
	} elsif (-f $path . '/' . $name) {
		$name =~ s/\.[^\/\.]+$//;
		$restore{$name}++;
	}
}

if ($default_path && opendir(DIR,$default_path)) {
	my(@db2);
	@db2 = readdir(DIR);
	closedir(DIR);
	foreach my $name (@db2) {
		next if $name =~ /^\./ || $name =~ /\.(txt|html|htm|gif|jpg|png)$/i || !-f $default_path . '/' . $name;
		$name =~ s/\.[^\/\.]+$//;
		$restore{$name}++;
	}
}

foreach my $name (keys %restore) {
	$check = 1 if $this->restore_db($default_path,$path,$name,$ext);
}
return $check;
}

######################################################################
# DBを復元
sub restore_db ($$$$$) {
my($this,$default_path,$path,$file,$ext) = @_;
my(%db,$check);
$file = $1 if (!defined $file || $file eq '') && defined $path && $path =~ s!/([^/]+)$!!;
return 0 if !defined $file || $file eq '' || $file =~ /\.(html|htm|ssi|js|gif|png|jpg|txt)$/i || !defined $path || !defined $ext;
$file =~ s/\.[^\/\.]+$//;
my $data = $this->read_file($path . '/' . $file . '.' . $ext);
$data = $this->read_file($default_path . '/' . $file . '.' . $ext) if !$data && $default_path;
return 0 if !$data;
my $home_dir_id = ($env::home_dir_id) ? $env::home_dir_id : '';
my $user_directory = $this->home_directory(1);
my $home_url = $this->full_path('../../',1);
my $home_url_encoded = $this->url_encode($home_url);
my $error = 0;
tie(%db, $env::dbm_file, $path . '/' . $file, O_RDWR | O_CREAT, $env::dbm_mode);
if (ref tied %db) {
	%db = () if ($main::clear || $file =~ /field$/) && (!defined $ext || $ext eq '' || $ext !~ /^_/);	#クリア
	while ($data =~ /([^\x09\x0A\x0D]+)\x09([^\x0A\x0D]*)[\x0A\x0D]*/sg) {
		my($k,$v) = ($1,$2);
		$k =~ s/\&#09;/\x09/gs;
		$k =~ s/\x0B/\x0A/gs;
		$k =~ s/[\x01-\x08\x0B-\x1F\x7F]+//gs;
		utf8::encode($k);
		if ($file eq 'record_id' && $k eq 'last') {
			$v = '';
		} else {
			$v =~ s/\&#09;/\x09/gs;
			$v =~ s/\x0B/\x0A/gs;
			$v =~ s/[\x01-\x08\x0B-\x1F\x7F]+//gs;
			$v =~ s!<home-dir-id>!$home_dir_id!gs;
			$v =~ s/<home-url>/$home_url/gs;
			$v =~ s/<home-url-encoded>/$home_url_encoded/gs;
			$v =~ s!<user-directory>!$user_directory!gs;
			utf8::encode($v);
		}
		eval '$db{$k} = $v;';
		$error++ if defined $@ && $@;
		$check = 1;
	}
} else {
	$check = 0;
}
untie %db;
push(@{$this->{'dialog'}},'容量が大き過ぎる' . $error . '件の設定復元に失敗しました(' . (($path =~ m!/(?:data|preferences)(/.+)$!) ? $1 . '/' : '') . $file . ')。') if $error;
return $check;
}

######################################################################
# 関連ファイルを復元
sub restore_relational_files ($$$) {
my($this,$id,$default_dir) = @_;
$id =~ s/\.default$//;
return if $id eq '';
while (my($name,$file) = each %backup::relational_file) {
	my $path = $default_dir . '/' . $file->{'path'} . '.' . $id . '.' . $file->{'ext'};
	$this->file_copy($path,$file->{'target'}) if -f $path;
}
}

######################################################################
# クラス登録
#sub import {
BEGIN {
	no warnings qw(once);

	#クラス登録
	Common::class_register('xxbr','Restore');

	#メニュー登録
	$setting::jump_menu{'xxbr'} = 'データベース・設定 の復元';
}


1;
